#ifndef __MVAUTOLANG_CLASS_HEADER_INCLUDED__
#define __MVAUTOLANG_CLASS_HEADER_INCLUDED__

/************************************************************************
	include files
************************************************************************/
#include <windows.h>



/************************************************************************
	declaration - CmvAutoLang
************************************************************************/
class CmvAutoLang
{
public:
	// <<< Constructor >>>
	CmvAutoLang () { NULL; }
	// >>> Destructor <<<
	virtual ~CmvAutoLang ()
	{
		if (m_dwResourceTable)
			delete [] m_dwResourceTable;
		m_dwResourceTable = NULL;
	}

	////////////////////////////////////////
	// ݒEݒl擾
	int GetLang () const { return (m_usLang); }
	int SetLang (USHORT nLang = 0)
	{
		if (! m_dwResourceTable)
			return (m_usLang = 0);
		if (nLang < 0 || m_dwResourceTable[0] <= nLang)
			return (m_usLang = 0);
		return (m_usLang = nLang);
	}

	////////////////////////////////////////
	// \[Xe[uݒ
	void SetTable (DWORD dwTable [])
	{
		// e[ũTCY擾
		if (! dwTable)
			return;
		USHORT n = (USHORT) dwTable[0];
		for (USHORT i = 1; dwTable[i] && i < 0xFFFF; i+=n) { NULL; }

		if (m_dwResourceTable)
			delete [] m_dwResourceTable;
		m_dwResourceTable = new DWORD [m_usSize = i];
		memcpy ((BYTE *) m_dwResourceTable, (BYTE *) dwTable, m_usSize * sizeof (DWORD));
	}

	////////////////////////////////////////
	// ݂̌ɉ\[XID擾
	DWORD GetID (DWORD dwID)
	{
		if (! m_dwResourceTable)
			return (0);
		USHORT m = m_usSize, n = (USHORT) m_dwResourceTable[0];
		for (USHORT i = 1; i < m; i+=n)
			if (m_dwResourceTable[i] == dwID)
				return (m_dwResourceTable[i + GetLang ()]);
		return (0);
	}

protected:
	static USHORT	m_usLang;
	static USHORT	m_usSize;
	static DWORD	*m_dwResourceTable;
};



extern CmvAutoLang					__cAutoLang;

// ܂
#define BEGIN_AUTOLANG_RESOURCE_TABLE \
		{ DWORD __cAutoLang_dwResourceTable [] = {
#define END_AUTOLANG_RESOURCE_TABLE \
		}; __cAutoLang.SetTable(__cAutoLang_dwResourceTable); }

#define AUTOLANG_SETLANG			__cAutoLang.SetLang
#define AUTOLANG_SETLANG_DEFAULT	__cAutoLang.SetLang
#define AUTOLANG_GETLANG			__cAutoLang.GetLang
#define AUTOLANG(x)					(__cAutoLang.GetID(x))

#endif // __MVAUTOLANG_CLASS_HEADER_INCLUDED__

// EOF