// CmvIniFile.hpp
/************************************************************************
	include files
************************************************************************/
#include <windows.h>
#define CLASS_INSTANCE
#include "CmvIniFile.hpp"

/************************************************************************
	CmvIniFile <<+ public>>
************************************************************************/

// DWORDl̓Ǎ
BOOL CmvIniFile::ReadInt (LPCTSTR section, LPCTSTR entry, LPDWORD data, DWORD default_data)
{
	if (section && *section && entry && *entry && data)
	{
		*data = GetPrivateProfileInt (section, entry, default_data, m_RootKeyName);
		return (TRUE);
	}	
	return (FALSE);
}

// ̓Ǎ
BOOL CmvIniFile::ReadStr (LPCTSTR section, LPCTSTR entry, LPSTR data, LPSTR default_data)
{
	if (section && *section && entry && *entry && data)
	{
		GetPrivateProfileString (section, entry, default_data, data, MAX_PATH, m_RootKeyName);
		return (TRUE);
	}	
	return (FALSE);
}

// DWORDl̏
BOOL CmvIniFile::WriteInt (LPCTSTR section, LPCTSTR entry, LPDWORD data)
{
	if (section && *section && entry && *entry && data)
	{
		char buf [MAX_PATH];
		wsprintf (buf, "%ld", *data);
		WritePrivateProfileString (section, entry, buf, m_RootKeyName);
		return (TRUE);
	}	
	return (FALSE);
}

// ̏
BOOL CmvIniFile::WriteStr (LPCTSTR section, LPCTSTR entry, LPSTR data)
{
	if (section && *section && entry && *entry && data)
	{
		WritePrivateProfileString (section, entry, data, m_RootKeyName);
		return (TRUE);
	}	
	return (FALSE);
}

////////////////////////////////////////////////////////////////////////
// lEL[̍폜
BOOL CmvIniFile::Delete (LPCTSTR section, LPCTSTR entry)
{
	if (! section) // t@CŜ̍폜
		DeleteFile (m_RootKeyName);
	else // lƃZNV̍폜
		WritePrivateProfileString (section, entry, NULL, m_RootKeyName);

	return (TRUE);
}

////////////////////////////////////////////////////////////////////////
// t@C̓etbV
BOOL CmvIniFile::Flush ()
{
	return (WritePrivateProfileString (NULL, NULL, NULL, m_RootKeyName));
}

// EOF