// main.cpp
/**********************************************************************
	AvP[ṼCt[
 **********************************************************************/
#include <windows.h>
#include <vfw.h>
#include "mymacro.h"
#include "Resource/resource.h"
#include "Class/CmvAutoLang.hpp"
#include "Class/CmvIniFile.hpp"
#include "Color.h"
#include "Camera.h"
#include "Dialog.h"

#include "global.h"

// Fop[^
LMSTypes arLMSTypes [] = {
		{ 1.0, 1.0, 1.0, FALSE },	// C^ - 
		{ 0.0, 1.0, 1.0, FALSE },	// P^/ - 1F
		{ 0.7, 1.0, 1.0, FALSE },	// P^/ - 1F
		{ 1.0, 0.0, 1.0, TRUE },	// D^/ - 2F
		{ 1.0, 0.7, 1.0, TRUE },	// D^/ - 2F
		{ 1.0, 1.0, 0.0, TRUE },	// T^ - 3F
		{ 0.0, 0.0, 0.0, TRUE },	// U^ - SF
		{ 0.7, 0.7, 0.7, TRUE },	// JX^ݒl
};

#define IDM_DEVICE_CAMERA	(IDM_DEVICE_MOUSE + 1)



/**********************************************************************
	̑낢
 **********************************************************************/

// ꃊ\[X̐ݒ
static void InitLanguageTable ()
{
	BEGIN_AUTOLANG_RESOURCE_TABLE
		2, // CMvAutoLang  2 ̃\[X ID Ǘ܂
		// _CAO
		IDD_CONFIG,				IDD_CONFIG_EN,
		IDD_CUSTOM,				IDD_CUSTOM_EN,
		// j[
		IDR_MENU,				IDR_MENU_EN,
		IDS_DEVICE_DISABLE,		IDS_DEVICE_DISABLE_EN,
		IDS_TYPE_C,				IDS_TYPE_C_EN,
		IDS_TYPE_P_HEAVY,		IDS_TYPE_P_HEAVY_EN,
		IDS_TYPE_P_LIGHT,		IDS_TYPE_P_LIGHT_EN,
		IDS_TYPE_D_HEAVY,		IDS_TYPE_D_HEAVY_EN,
		IDS_TYPE_D_LIGHT,		IDS_TYPE_D_LIGHT_EN,
		IDS_TYPE_T,				IDS_TYPE_T_EN,
		IDS_TYPE_U,				IDS_TYPE_U_EN,
		IDS_TYPE_CUSTOM,		IDS_TYPE_CUSTOM_EN,
		// e[u
		IDS_ERR_START_DEVICE,	IDS_ERR_START_DEVICE_EN,
	END_AUTOLANG_RESOURCE_TABLE

	// vÕt@C擾
	char buf [MAX_PATH];
	GetModuleFileName (GetModuleHandle (NULL), buf, sizeof (buf));
	for (int offset = lstrlen (buf); offset && buf[offset] != '\\'; offset--) { NULL; } offset++;

	#define FILENAME_JP		"_jp.exe"
	#define FILENAME_EN		"_en.exe"

	// XXX_jp.exe  {ꃊ\[X
	if (lstrcmpi (buf + lstrlen (buf) - lstrlen (FILENAME_JP), FILENAME_JP) == 0)
		AUTOLANG_SETLANG (0);
	// XXX_en.exe  pꃊ\[X
	else if (lstrcmpi (buf + lstrlen (buf) - lstrlen (FILENAME_EN), FILENAME_EN) == 0)
		AUTOLANG_SETLANG (1);
	// XXX.exe  OS ̃P[ɂ莩I
	else {
		// ꃍP[ID
		WORD wLang = LANGIDFROMLCID (GetUserDefaultLCID ());
		if (wLang == 0x0411)
			AUTOLANG_SETLANG (0);
		else
			AUTOLANG_SETLANG (1);
	}
}

////////////////////////////////////////////////////////////////////////
// j[ڂ̐ݒ
static void UpdateWindowMenu (HWND hWnd)
{
	ASSERT (hWnd);

	HMENU hMenu = GetMenu (hWnd);
	if (! hMenu)
		return;

	// foCX^Cv
	if (gCfg.uiDevice < IDM_DEVICE_MOUSE)
		gCfg.uiDevice = IDM_DEVICE_MOUSE;
	CheckMenuRadioItem (hMenu, IDM_DEVICE_MOUSE, IDM_DEVICE_CAMERA + 9, gCfg.uiDevice, MF_BYCOMMAND);

	// Fo^Cv
	if (gCfg.uiType < IDS_TYPE_C)
		gCfg.uiType = IDS_TYPE_C;
	if (IDS_TYPE_CUSTOM < gCfg.uiType)
		gCfg.uiType = IDS_TYPE_CUSTOM;
	CheckMenuRadioItem (hMenu, IDS_TYPE_C, IDS_TYPE_CUSTOM, gCfg.uiType, MF_BYCOMMAND);

	// EBhD^CgύX
	char buf [BUFSIZE];
	int len = LoadString (gApp.hInstance, AUTOLANG (gCfg.uiType), buf, sizeof (buf));
	if (len)
	{
		char title [BUFSIZE];
		wsprintf (title, "%s [%s]", APPLI_NAME, buf);
		SetWindowText (hWnd, title);
	}

	// ɎOɕ\
	CheckMenuItem (hMenu, IDM_TOPMOST, MF_BYCOMMAND | (gCfg.bTopMost ? MF_CHECKED : MF_UNCHECKED));
	SetWindowPos (hWnd,
			gCfg.bTopMost ? HWND_TOPMOST : HWND_NOTOPMOST,
			0,0, 0,0, SWP_NOMOVE | SWP_NOSIZE);
}

////////////////////////////////////////////////////////////////////////
//  }EXJ[\t߂̉ʂLv`
static void CaptureScreen (HWND hWnd)
{
	ASSERT (hWnd);

	if (! gApp.cScrn)
		return;

	// }EXJ[\ʒu擾
	POINT pt;
	GetCursorPos (&pt);	

	// NCAgTCY擾
	RECT rectClient;
	GetClientRect (hWnd, &rectClient);

	// wiFŃNA
	FillRect (gApp.cScrn->GetDC (), &rectClient, (HBRUSH) (COLOR_APPWORKSPACE + 1));

	// }EXJ[\t߂̉摜擾
	HDC hdcScrn = GetDC (HWND_DESKTOP);
	if (! hdcScrn)
		return;

	::BitBlt (
			gApp.cScrn->GetDC (), 0,0, rectClient.right, rectClient.bottom,
			hdcScrn, pt.x - rectClient.right / 2, pt.y - rectClient.bottom / 2,
			SRCCOPY);
	ReleaseDC (HWND_DESKTOP, hdcScrn);
}

////////////////////////////////////////////////////////////////////////
// IꂽfoCXɂăEBhD̍őŏ肷
static void SetMinMaxTrackSize (HWND hWnd)
{
	// EBhDTCY擾
	RECT rectWindow, rectClient;
	GetWindowRect (hWnd, &rectWindow);
	GetClientRect (hWnd, &rectClient);
	UINT margin_x = rectWindow.right - rectWindow.left - rectClient.right;
	UINT margin_y = rectWindow.bottom - rectWindow.top - rectClient.bottom;

	if (gCfg.uiDevice == IDM_DEVICE_MOUSE)
	{
		gApp.rectMinTrackSize.cx = margin_x + WINDOW_MIN_SIZE_X;
		gApp.rectMinTrackSize.cy = margin_y + WINDOW_MIN_SIZE_Y;
		gApp.rectMaxTrackSize.cx = margin_x + WINDOW_MAX_SIZE_X;
		gApp.rectMaxTrackSize.cy = margin_y + WINDOW_MAX_SIZE_Y;
	}
	else {
		BITMAPINFO bmi;
		GetCameraCaps (&bmi);
		gApp.rectMinTrackSize.cx = gApp.rectMaxTrackSize.cx = margin_x + bmi.bmiHeader.biWidth;
		gApp.rectMinTrackSize.cy = gApp.rectMaxTrackSize.cy = margin_y + bmi.bmiHeader.biHeight;
	}

	// EBhDTCYXV
	MoveWindow (hWnd,
			rectWindow.left,
			rectWindow.top,
			margin_x + rectClient.right,
			margin_y + rectClient.bottom,
			TRUE);
}



/**********************************************************************
	ݒt@C֌W
 **********************************************************************/

#define INI_SECTION_GENERAL				"General"
#define	INI_TIMER_INTERVAL				"TimerInterval"
#define INI_TOP_MOST					"AlwaysTopMost"
#define INI_COLOR_TYPE					"ColorType"

#define INI_SECTION_CUSTOM_COLOR		"CustomColor"
#define INI_L							"L"
#define INI_M							"M"
#define INI_S							"S"
#define INI_SUP							"Supplement"

#define INI_SECTION_WINDOW				"Window"
#define INI_TOP							"Top"
#define INI_RIGHT						"Right"
#define INI_BOTTOM						"Bottom"
#define INI_LEFT						"Left"

// ݒeǂݏo
static void ReadConfigSetting ()
{
	// ݒt@C̃pX
	char ini_path [MAX_PATH];
	GetModuleFileName (NULL, ini_path, MAX_PATH);
	for (int i = lstrlen (ini_path); (i + 1 && ini_path [i] != '\\'); i--)
		ini_path [i] = '\0';
	lstrcat (ini_path, APPLI_NAME ".ini");

	// ݒt@CȂꍇ͋K̐ݒlp
	if (GetFileAttributes (ini_path) == (DWORD) -1)
	{
		gCfg.uiTimerInterval = INITIAL_TIMER_INTERVAL;
		gCfg.bTopMost = INITIAL_TOP_MOST;
		gCfg.uiType = INITIAL_TYPE;
		return;
	}

	// t@Cǂݍ
	gCfg.ini = new CmvIniFile (ini_path);
	if (gCfg.ini)
	{
		DWORD value;
		// S
		gCfg.ini->ReadInt (INI_SECTION_GENERAL, INI_TIMER_INTERVAL, &value, INITIAL_TIMER_INTERVAL);
		gCfg.uiTimerInterval = value;
		gCfg.ini->ReadInt (INI_SECTION_GENERAL, INI_TOP_MOST, &value, INITIAL_TOP_MOST);
		gCfg.bTopMost = value;
		gCfg.ini->ReadInt (INI_SECTION_GENERAL, INI_COLOR_TYPE, &value, INITIAL_TYPE);
		gCfg.uiType = value;
		// FõJX^ݒl
		gCfg.ini->ReadInt (INI_SECTION_CUSTOM_COLOR, INI_L, &value,	(int) (arLMSTypes[CUSTOM_SETTING].dL * 100));
		arLMSTypes[CUSTOM_SETTING].dL = (double) value / 100.0;
		gCfg.ini->ReadInt (INI_SECTION_CUSTOM_COLOR, INI_M, &value,	(int) (arLMSTypes[CUSTOM_SETTING].dM * 100));
		arLMSTypes[CUSTOM_SETTING].dM = (double) value / 100.0;
		gCfg.ini->ReadInt (INI_SECTION_CUSTOM_COLOR, INI_S, &value,	(int) (arLMSTypes[CUSTOM_SETTING].dS * 100));
		arLMSTypes[CUSTOM_SETTING].dS = (double) value / 100.0;
		gCfg.ini->ReadInt (INI_SECTION_CUSTOM_COLOR, INI_SUP, &value, (int) arLMSTypes[CUSTOM_SETTING].bSup);
		arLMSTypes[CUSTOM_SETTING].bSup = (BOOL) value;
	}
}

// EBhDʒu̓ǂݏo
static void ReadConfigSettingWindow (HWND hWnd)
{
	if (gCfg.ini)
	{
		RECT rectWindow;
		gCfg.ini->ReadInt (INI_SECTION_WINDOW, INI_TOP, (DWORD *) &rectWindow.top);
		gCfg.ini->ReadInt (INI_SECTION_WINDOW, INI_RIGHT, (DWORD *) &rectWindow.right);
		gCfg.ini->ReadInt (INI_SECTION_WINDOW, INI_BOTTOM, (DWORD *) &rectWindow.bottom);
		gCfg.ini->ReadInt (INI_SECTION_WINDOW, INI_LEFT, (DWORD *) &rectWindow.left);

		if (! IsRectEmpty (&rectWindow))
			MoveWindow (hWnd,
					rectWindow.left,
					rectWindow.top,
					rectWindow.right - rectWindow.left,
					rectWindow.bottom - rectWindow.top,
					FALSE);
	}
}

// ݒeo
static void WriteConfigSetting (HWND hWnd)
{
	// ݒۑȂ
	if (gCfg.ini)
	{
		DWORD value;
		// S
		value = (DWORD) gCfg.uiTimerInterval;
		gCfg.ini->WriteInt (INI_SECTION_GENERAL, INI_TIMER_INTERVAL, &value);
		value = (DWORD) gCfg.bTopMost;
		gCfg.ini->WriteInt (INI_SECTION_GENERAL, INI_TOP_MOST, &value);
		value = (DWORD) gCfg.uiType;
		gCfg.ini->WriteInt (INI_SECTION_GENERAL, INI_COLOR_TYPE, &value);
		// FõJX^ݒl
		value = (DWORD) (arLMSTypes[CUSTOM_SETTING].dL * 100);
		gCfg.ini->WriteInt (INI_SECTION_CUSTOM_COLOR, INI_L, &value);
		value = (DWORD) (arLMSTypes[CUSTOM_SETTING].dM * 100);
		gCfg.ini->WriteInt (INI_SECTION_CUSTOM_COLOR, INI_M, &value);
		value = (DWORD) (arLMSTypes[CUSTOM_SETTING].dS * 100);
		gCfg.ini->WriteInt (INI_SECTION_CUSTOM_COLOR, INI_S, &value);
		value = (DWORD) arLMSTypes[CUSTOM_SETTING].bSup;
		gCfg.ini->WriteInt (INI_SECTION_CUSTOM_COLOR, INI_SUP, &value);

		// EBhD̈ʒu
		if (! IsIconic (hWnd))
		{
			RECT rectWindow;
			GetWindowRect (hWnd, &rectWindow);
			gCfg.ini->WriteInt (INI_SECTION_WINDOW, INI_TOP, (DWORD *) &rectWindow.top);
			gCfg.ini->WriteInt (INI_SECTION_WINDOW, INI_RIGHT, (DWORD *) &rectWindow.right);
			gCfg.ini->WriteInt (INI_SECTION_WINDOW, INI_BOTTOM, (DWORD *) &rectWindow.bottom);
			gCfg.ini->WriteInt (INI_SECTION_WINDOW, INI_LEFT, (DWORD *) &rectWindow.left);
		}

		// n
		delete gCfg.ini;
	}
}



/**********************************************************************
	CEBhD̏ƌn
 **********************************************************************/
// 
static int InitializeMyWindow (HWND hWnd)
{
	char buf [BUFSIZE];
	HMENU hMenu;

	////////////////////////////////////////
	// j[쐬 - Lv`foCX
	hMenu = GetSubMenu (GetMenu (hWnd), 1);
	gCfg.uiDevice = IDM_DEVICE_MOUSE;
	for (int i = 9; 0 <= i; i--)
	{
		char ver [BUFSIZE];
		if (! capGetDriverDescription (i, buf, sizeof (buf), ver, sizeof (ver)))
			continue;
		gCfg.uiDevice = IDM_DEVICE_CAMERA + i;
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, gCfg.uiDevice, buf);
	}
	if (gCfg.uiDevice == IDM_DEVICE_MOUSE)
	{
		if (LoadString (gApp.hInstance, AUTOLANG (IDS_DEVICE_DISABLE), buf, sizeof (buf)))
			InsertMenu (hMenu, 0, MF_BYPOSITION | MF_GRAYED | MF_STRING, IDS_DEVICE_DISABLE, buf);
	}
	gCfg.uiDevice = IDM_DEVICE_MOUSE;

	////////////////////////////////////////
	// j[쐬 - Foݒ
	hMenu = GetSubMenu (GetMenu (hWnd), 2);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_CUSTOM), buf, sizeof (buf)))
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_CUSTOM, buf);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_U), buf, sizeof (buf)))
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_U, buf);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_T), buf, sizeof (buf)))
		lstrcat (buf, "\tAlt"), //
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_T, buf);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_D_LIGHT), buf, sizeof (buf)))
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_D_LIGHT, buf);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_D_HEAVY), buf, sizeof (buf)))
		lstrcat (buf, "\tCtrl"), //
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_D_HEAVY, buf);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_P_LIGHT), buf, sizeof (buf)))
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_P_LIGHT, buf);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_P_HEAVY), buf, sizeof (buf)))
		lstrcat (buf, "\tShift"), //
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_P_HEAVY, buf);
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_TYPE_C), buf, sizeof (buf)))
		InsertMenu (hMenu, 0, MF_BYPOSITION | MF_CHECKED | MF_STRING, IDS_TYPE_C, buf);

	// ݒt@Ceݒǂݏo
	ReadConfigSetting ();

	// ĕ`p^C}
	SetTimer (hWnd, TIMER_EVENT_ID, gCfg.uiTimerInterval * TIMER_INTERVAL, NULL);

	// `pT[tFX
	gApp.cScrn = new CmvSurface ();
	if (! gApp.cScrn)
		return (FALSE);
	// Ƃ肠
	gApp.cScrn->Create (100,100);

	// Lv`foCX̏
	InitializeCamera (hWnd);

	// j[̏l
	UpdateWindowMenu (hWnd);

	// EBhDTCYXV
	SetMinMaxTrackSize (hWnd);

	// EBhDʒuݒ
	ReadConfigSettingWindow (hWnd);

	return (TRUE);
}

////////////////////////////////////////////////////////////////////////
// n
static int FinalizeMyWindow (HWND hWnd)
{
	// ݒt@CɊeݒ߂
	WriteConfigSetting (hWnd);

	// Lv`foCX̌n
	FinalizeCamera (hWnd);

	// `pT[tFX
	if (gApp.cScrn)
		delete gApp.cScrn;
	gApp.cScrn = NULL;

	// ĕ`p^C}
	KillTimer (hWnd, TIMER_EVENT_ID);

	return (TRUE);
}



/**********************************************************************
	CEBhD̃bZ[W
 **********************************************************************/
// obNobt@ʂɕ`
static BOOL OnPaint (HWND hWnd)
{
	ASSERT (hWnd);
	ASSERT (gApp.cScrn);

	PAINTSTRUCT ps;
	HDC hdc = BeginPaint (hWnd, &ps);
	gApp.cScrn->BitBlt (hdc, 0,0);
	EndPaint (hWnd, &ps);

	return (0);
}

////////////////////////////////////////////////////////////////////////
// [ɎOɕ\]j[
static BOOL OnCommandTopMost (HWND hWnd)
{
	ASSERT (hWnd);

	gCfg.bTopMost = ! gCfg.bTopMost;
	UpdateWindowMenu (hWnd);

	return (0);
}



/**********************************************************************
	CEBhD̃bZ[WvV[W
 **********************************************************************/
static LRESULT CALLBACK WndProcMain (HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch (msg)
	{
		////////////////////////////////////////
		// EBhD̐Ɣj
		case WM_CREATE:
			if (! InitializeMyWindow (hWnd))
				return (-1);
			return (0);

		case WM_CLOSE:
			FinalizeMyWindow (hWnd);
			DestroyWindow (hWnd);
			return (0);

		case WM_DESTROY:
			PostQuitMessage (0);
			return (0);

		case WM_SIZE: {
			if (wParam == SIZE_MINIMIZED)
				break;

			int width = ((LOWORD (lParam) + 3) / 4) * 4;
			int height = HIWORD (lParam);

			ASSERT (gApp.cScrn);
			gApp.cScrn->Create (width, height);
			return (0);
		}

		case WM_GETMINMAXINFO: {
			ASSERT (lParam);
			MINMAXINFO *mmi = (MINMAXINFO *) lParam;
			mmi->ptMinTrackSize.x = gApp.rectMinTrackSize.cx;
			mmi->ptMinTrackSize.y = gApp.rectMinTrackSize.cy;
			mmi->ptMaxTrackSize.x = gApp.rectMaxTrackSize.cx;
			mmi->ptMaxTrackSize.y = gApp.rectMaxTrackSize.cy;
			return (0);
		}

		////////////////////////////////////////
		// `
		case WM_TIMER:
			if (! IsIconic (hWnd))
			{
				// Lv`
				if (gCfg.uiDevice == IDM_DEVICE_MOUSE)
					CaptureScreen (hWnd);
				else
					CaptureCamera (hWnd);

				UINT uiType = gCfg.uiType;
				if (GetAsyncKeyState (VK_SHIFT) & 0x8000)
					uiType = IDS_TYPE_P_HEAVY;
				if (GetAsyncKeyState (VK_CONTROL) & 0x8000)
					uiType = IDS_TYPE_D_HEAVY;
				if (GetAsyncKeyState (VK_MENU) & 0x8000)
					uiType = IDS_TYPE_T;

				ConvertColors (
						gApp.cScrn->GetBit (), gApp.cScrn->GetWidth (), gApp.cScrn->GetHeight (),
						arLMSTypes[uiType - IDS_TYPE_C].dL,
						arLMSTypes[uiType - IDS_TYPE_C].dM,
						arLMSTypes[uiType - IDS_TYPE_C].dS,
						arLMSTypes[uiType - IDS_TYPE_C].bSup);
				InvalidateRect (hWnd, NULL, FALSE);
				UpdateWindow (hWnd);
			}
			return (0);

		case WM_PAINT:
			return (OnPaint (hWnd));
		
		////////////////////////////////////////
		// R}h
		case WM_COMMAND:
			switch (LOWORD (wParam))
			{
			case IDM_EXIT:
				PostMessage (hWnd, WM_CLOSE, 0,0);
				return (0);

			// foCXI
			case IDM_DEVICE_MOUSE:
			case IDM_DEVICE_CAMERA + 0:
			case IDM_DEVICE_CAMERA + 1:
			case IDM_DEVICE_CAMERA + 2:
			case IDM_DEVICE_CAMERA + 3:
			case IDM_DEVICE_CAMERA + 4:
			case IDM_DEVICE_CAMERA + 5:
			case IDM_DEVICE_CAMERA + 6: 
			case IDM_DEVICE_CAMERA + 7:
			case IDM_DEVICE_CAMERA + 8:
			case IDM_DEVICE_CAMERA + 9:
				gCfg.uiDevice = LOWORD (wParam);
				InitializeCamera (hWnd);
				UpdateWindowMenu (hWnd);
				SetMinMaxTrackSize (hWnd);
				return (0);

			// Foݒ
			case IDS_TYPE_C:
			case IDS_TYPE_P_HEAVY:
			case IDS_TYPE_P_LIGHT:
			case IDS_TYPE_D_HEAVY:
			case IDS_TYPE_D_LIGHT:
			case IDS_TYPE_T:
			case IDS_TYPE_U:
			case IDS_TYPE_CUSTOM:
				gCfg.uiType = LOWORD (wParam);
				UpdateWindowMenu (hWnd);
				if (gCfg.uiType == IDS_TYPE_CUSTOM)
					DialogCustomSetting (hWnd);
				return (0);

			case IDM_TOPMOST:
				return (OnCommandTopMost (hWnd));

			case IDM_CONFIG:
				DialogProgramConfig (hWnd);				
				return (0);

			case IDM_ABOUT:
				return (DialogAbout (hWnd));

			}
			break;

		case WM_SYSCOMMAND:
			switch (wParam)
			{
			case SC_CLOSE:
				PostMessage (hWnd, WM_CLOSE, 0,0L);
				return (0);
			}
			break;
	}

	return DefWindowProc (hWnd, msg, wParam, lParam);
}



/**********************************************************************
	WinMain - vÕGg|Cg
 **********************************************************************/
#define MUTEX_NAME	APPLI_NAME "_WindowMutex"
#define CLASS_NAME	APPLI_NAME "_WindowClass"

int WINAPI WinMain (HINSTANCE hInst, HINSTANCE hPrvInst, LPSTR lpCmdLine, int nCmdShow)
{
	// CX^X̕ۑ
	gApp.hInstance = hInst;

	// ꃊ\[X̐ݒ
	InitLanguageTable ();

	// EBhDNX̓o^
	if (! hPrvInst) {
		WNDCLASS wc;
		wc.style			= NULL;
		wc.lpfnWndProc		= (WNDPROC) WndProcMain;
		wc.cbClsExtra		= 0;
		wc.cbWndExtra		= 0;
		wc.hInstance		= gApp.hInstance;
		wc.hIcon			= LoadIcon (gApp.hInstance, MAKEINTRESOURCE (IDI_APPLI));
		wc.hCursor			= LoadCursor (NULL, IDC_ARROW);
		wc.hbrBackground	= NULL;
		wc.lpszMenuName		= MAKEINTRESOURCE (AUTOLANG (IDR_MENU));
		wc.lpszClassName	= CLASS_NAME;

		if (! RegisterClass (&wc)) {
			return (FALSE);
		}
	}

	// EBhD̍쐬ƕ\
	HWND hWnd = CreateWindow (
			CLASS_NAME, APPLI_NAME,
			WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_THICKFRAME | WS_MINIMIZEBOX,
			CW_USEDEFAULT,0, WINDOW_MIN_SIZE_X,WINDOW_MIN_SIZE_Y,
			NULL, NULL, gApp.hInstance, NULL);
	if (! hWnd)
	{
		return (FALSE);
	}
	ShowWindow (hWnd, nCmdShow);
	UpdateWindow (hWnd);

	MSG msg;
	while (GetMessage (&msg, (HWND) NULL, 0,0))
	{
		TranslateMessage (&msg);
		DispatchMessage (&msg);
	}

	// vȌI
	return (msg.lParam);  
}

/*EOF*/
